<template>
  <div class="container-fluid">
    <div class="row">
      <div class="col-md-3">
          <div class="form-group">
            <h2>Create Constituent</h2>
            <label>First Name</label>
            <input class="form-control" v-model="constituent.firstName">
          </div>

          <div class="form-group">
            <label>Middle Name</label>
            <input class="form-control" v-model="constituent.middleName">
          </div>

          <div class="form-group">
            <label>Last Name</label>
            <input class="form-control" v-model="constituent.lastName">
          </div>

          <div class="form-group">
            <label>Gender</label>
              <select class="form-control" v-model="constituent.gender">
                <option>Male</option>
                <option>Female</option>
              </select>
          </div>
          <div class="form-group">
            <button class="btn btn-primary mb-2 form-control" @click="showmModalSaveConstituent()">Save</button>
          </div>
      </div>
      
      <div class="col-md-9">
        <table class="table table-bordered">
          <thead class="thead-light">
            <tr>
              <th scope="col">ID</th>
              <th scope="col">First Name</th>
              <th scope="col">Middle Name</th>
              <th scope="col">Last Name</th>
              <th scope="col">Gender</th>
              <th scope="col 2">Action</th>
            </tr>
          </thead>
          <tbody v-for="constituentInfo in constituentInfo" :key="constituentInfo.ID">
            <td>{{ constituentInfo.Id }}</td>
            <td>{{ constituentInfo.FirstName }}</td>
            <td>{{ constituentInfo.MiddleName }}</td>
            <td>{{ constituentInfo.LastName }}</td>
            <td>{{ constituentInfo.Gender }}</td>
            <td>
              <button class="btn btn-primary mb-2" data-toggle="modal" @click="showModalUpdateConsituent(constituentInfo.Id)">Update</button>
              <button class="btn btn-danger mb-2" :id="constituentInfo.Id" @click="showmModalDeleteConstituent(constituentInfo.Id)">Delete</button>
            </td>
          </tbody>
        </table>
      </div>
      
    </div>

    <modal name="modalUpdateConsituent" height="auto" width="50%" :scrollable="true" :adaptive="true" :clickToClose="false">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLongTitle">Update Constituent</h5>
          <!-- <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button> -->
        </div>
        <div class="modal-body">
          <div class="row">
            <div class="col-md-3">
              <div class="form-group">
                <label>First Name</label>
                <input class="form-control" v-model="updateConstituentInfo.firstName">
              </div>
            </div>

            <div class="col-md-3">
              <div class="form-group">
                <label>Middle Name</label>
                <input class="form-control" v-model="updateConstituentInfo.middleName">
              </div>
            </div>

            <div class="col-md-3">
              <div class="form-group">
                <label>Last Name</label>
                <input class="form-control" v-model="updateConstituentInfo.lastName">
              </div>
            </div>

            <div class="col-md-3">
              <div class="form-group">
                <label>Suffix</label>
                <input class="form-control" v-model="updateConstituentInfo.suffix">
              </div>
            </div>
          </div>

          <div class="row">
            <div class="col-md-4">
              <div class="form-group">
                <label>Gender</label>
                  <select class="form-control" v-model="updateConstituentInfo.gender">
                    <option>Male</option>
                    <option>Female</option>
                  </select>
              </div>
            </div>

            <div class="col-md-4">
              <div class="form-group">
                <label>Birthday</label>
                <input class="form-control" v-model="updateConstituentInfo.birthday">
              </div>
            </div>

            <div class="col-md-4">
              <div class="form-group">
                <label>Birthplace</label>
                <input class="form-control" v-model="updateConstituentInfo.birthplace">
              </div>
            </div>            
          </div>

          <div class="row">
            <div class="col-md-4">
              <div class="form-group">
                <label>Civil Status</label>
                <input class="form-control" v-model="updateConstituentInfo.civilstatus">
              </div>
            </div>

            <div class="col-md-4">
              <div class="form-group">
                <label>Citizenship</label>
                <input class="form-control" v-model="updateConstituentInfo.citizenship">
              </div>
            </div>

            <div class="col-md-4">
              <div class="form-group">
                <label>Religion</label>
                <input class="form-control" v-model="updateConstituentInfo.religion">
              </div>
            </div>            
          </div>

          <div class="row">
            <div class="col-md-6">
              <div class="form-group">
                <label>Email</label>
                <input class="form-control" v-model="updateConstituentInfo.email">
              </div>
            </div>

            <div class="col-md-6">
              <div class="form-group">
                <label>PhoneNumber</label>
                <input class="form-control" v-model="updateConstituentInfo.phoneNumber">
              </div>
            </div>
          </div>

          <div class="row">
            <div class="col-md-6">
              <div class="form-group">
                <label>Fathers Name</label>
                <input class="form-control" v-model="updateConstituentInfo.fathersName">
              </div>
            </div>
            
            <div class="col-md-6">
              <div class="form-group">
                <label>Mothers Name</label>
                <input class="form-control" v-model="updateConstituentInfo.mothersName">
              </div>
            </div>
          </div>

          <div class="form-group">
            <label>isDeceased</label>
            <input class="form-control">
          </div>

        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal" @click="hideModalUpdateConsituent">Close</button>
          <button type="button" class="btn btn-primary" @click="updateConstituent()">Save</button>
        </div>
      </div>
    </modal>
  </div>
</template>

<script>
import axios from 'axios'
export default {
  name: 'HelloWorld',
  data () {
    return {
      globalURL: localStorage.getItem('URL'),
      constituentInfo: [],
      constituent: {
        firstName: '',
        middleName: '',
        lastName: '',
        gender: ''
      },
      updateConstituentInfo: {
        firstName: '',
        middleName: '',
        lastName: '',
        suffix: '',
        mothersName: '',
        fathersName: '',
        gender: '',
        civilstatus: '',
        birthday: '',
        birthplace: '',
        phoneNumber: '',
        citizenship: '',
        religion: '',
        email: ''
      },
      constituentFooID: ''
    }
  },

  created () {
    this.getConstituent()
  },

  methods: {
    showModalUpdateConsituent (fooID) {
      console.log(fooID)
      this.constituentFooID = fooID;
      this.getConstituentByID();
      this.$modal.show('modalUpdateConsituent');
    },

    hideModalUpdateConsituent () {
      this.$modal.hide('modalUpdateConsituent');
    },

    showmModalDeleteConstituent (fooID) {
      axios.delete(this.globalURL + 'delete-constituent/' + fooID , {
        // Id: fooID
      }).then(response => {
        console.log('deleted ' + fooID)
        this.getConstituent()
        alert('Successfully Deleted');
      }, (error) => { console.log(error) })
    },

    showmModalSaveConstituent () {
      this.addConstituent()
    },

    getConstituent () {
      axios.get(this.globalURL + 'constituent' , {
      }).then(response => {
        console.table(response.data)
        this.constituentInfo = response.data
        if (response.statusText === 'OK') {

        } else {
          console.log('BOBO')
        }
      }, (error) => { console.log(error) })
    },

    getConstituentByID () {
      axios.get(this.globalURL + 'get-constituent-byID/' + this.constituentFooID, {
      }).then(response => {
        console.log(response.data)
        for (var i = 0; i < response.data.length; i++) { 
          this.updateConstituentInfo.firstName = response.data[i].FirstName;
          this.updateConstituentInfo.middleName = response.data[i].MiddleName;
          this.updateConstituentInfo.lastName = response.data[i].LastName;
          this.updateConstituentInfo.suffix = response.data[i].Suffix;
          this.updateConstituentInfo.mothersName = response.data[i].MothersName;
          this.updateConstituentInfo.fathersName = response.data[i].FathersName;
          this.updateConstituentInfo.gender = response.data[i].Gender;
          this.updateConstituentInfo.civilstatus = response.data[i].CivilStatus;
          this.updateConstituentInfo.birthday = response.data[i].Birthday;
          this.updateConstituentInfo.birthplace = response.data[i].Birthplace;
          this.updateConstituentInfo.phoneNumber = response.data[i].PhoneNumber;
          this.updateConstituentInfo.citizenship = response.data[i].Citizenship;
          this.updateConstituentInfo.email = response.data[i].Email;
          this.updateConstituentInfo.religion = response.data[i].Religion;
        };
      }, (error) => { console.log(error) })
    },

    addConstituent () {
      axios.post(this.globalURL + 'add-constituent', {
        FirstName: this.constituent.firstName,
        MiddleName: this.constituent.middleName,
        LastName: this.constituent.lastName,
        Suffix: 'n/a',
        MothersName: '',
        FathersName: '',
        Gender: this.constituent.gender,
        CivilStatus: '',
        Birthday: '',
        Birthplace: '',
        PhoneNumber: 19,
        Citizenship: '',
        Religion: '',
        Email: 'n/a'
      }).then(response => {
        console.log('Added ' + this.constituent.firstName + ' ' + this.constituent.middleName + ' ' + this.constituent.lastName + ' ' + this.constituent.gender)
        this.getConstituent()
      }, (error) => { console.log(error) })
    },

    updateConstituent () {
      axios.patch(this.globalURL + 'update-constituent/' + this.constituentFooID, {
        FirstName: this.updateConstituentInfo.firstName,
        MiddleName: this.updateConstituentInfo.middleName,
        LastName: this.updateConstituentInfo.lastName,
        Suffix: this.updateConstituentInfo.suffix,
        MothersName: this.updateConstituentInfo.mothersName,
        FathersName: this.updateConstituentInfo.fathersName,
        Gender: this.updateConstituentInfo.gender,
        CivilStatus: this.updateConstituentInfo.civilstatus,
        Birthday: this.updateConstituentInfo.birthday,
        Birthplace: this.updateConstituentInfo.birthplace,
        PhoneNumber: this.updateConstituentInfo.phoneNumber,
        Citizenship: this.updateConstituentInfo.citizenship,
        Religion: this.updateConstituentInfo.religion,
        Email: this.updateConstituentInfo.email,
      }).then(response => {
        this.getConstituent()
      }, (error) => { console.log(error) })
    }
  }, 
}
</script>

